/*
	Eiffel Display program
*/

#include	<stdio.h>
#include	<tos.h>

/*	--------------------------------------------------------------	*/
/*	Keyboard	*/

#define		ESC					0x01
#define		UNDO				0x61
#define		HELP				0x62
#define		SCROLL				0x4C
#define		PAGEUP				0x45
#define		PAGEDOWN			0x46
#define		END					0x55
#define		PRINTSCREEN			0x49
#define		PAUSE				0x4F
#define		VERRNUM				0x54
#define		LEFTWIN				0x56
#define		RIGHTWIN			0x57
#define		APPWIN				0x58

/*	--------------------------------------------------------------	*/
/*	Mouse	*/

#define		WHEELUP				0x59
#define		WHEELDOWN			0x60

/*	--------------------------------------------------------------	*/
void Display( int Key )
{
	switch( Key ) {
	
		case	UNDO:
				fprintf( stdout, "Scan code: 0x%2X\tUndo/F12\n", (int)Key, (int)Key );
				break;
				
		case	HELP:
				fprintf( stdout, "Scan code: 0x%2X\tHelp/F11\n", (int)Key, (int)Key );
				break;
					
		case	SCROLL:
				fprintf( stdout, "Scan code: 0x%2X\tScroll/Arrt dfil\n", (int)Key, (int)Key );
				break;

		case	PAGEUP:
				fprintf( stdout, "Scan code: 0x%2X\tPage Up\n", (int)Key, (int)Key );
				break;

		case	PAGEDOWN:
				fprintf( stdout, "Scan code: 0x%2X\tPage Down\n", (int)Key, (int)Key );
				break;

		case	END:
				fprintf( stdout, "Scan code: 0x%2X\tEnd\n", (int)Key, (int)Key );
				break;

		case	PRINTSCREEN:
				fprintf( stdout, "Scan code: 0x%2X\tPrint Screen/Impr cran\n", (int)Key, (int)Key );
				break;

		case	PAUSE:
				fprintf( stdout, "Scan code: 0x%2X\tPause\n", (int)Key, (int)Key );
				break;

		case	VERRNUM:
				fprintf( stdout, "Scan code: 0x%2X\tVerr Num\n", (int)Key, (int)Key );
				break;

		case	LEFTWIN:
				fprintf( stdout, "Scan code: 0x%2X\tLeft Windows\n", (int)Key, (int)Key );
				break;

		case	RIGHTWIN:
				fprintf( stdout, "Scan code: 0x%2X\tRight Windows\n", (int)Key, (int)Key );
				break;

		case	APPWIN:
				fprintf( stdout, "Scan code: 0x%2X\tAPP WINDOWS\n", (int)Key, (int)Key );
				break;

		case	WHEELUP:
				fprintf( stdout, "Scan code: 0x%2X\tWheel Up\n", (int)Key, (int)Key );
				break;

		case	WHEELDOWN:
				fprintf( stdout, "Scan code: 0x%2X\tWheel Down\n", (int)Key, (int)Key );
				break;

		default:
				fprintf( stdout, "Scan code: 0x%2X\t%c\n", (int)Key, (unsigned char)Key );
				break;
	}
}
/*	--------------------------------------------------------------	*/
int main()
{
	unsigned long	Key;
	
	fprintf( stdout, "\033E" );
	fprintf( stdout, "\033p" );
	fprintf( stdout, "Eiffel Scan-Code display: Get with Crawcin() scan-code comming from Eiffel\n" );
	fprintf( stdout, "Favard L.\n" );
	fprintf( stdout, "\033q" );
	fprintf( stdout, "Press ESC key to exit\n" );
	
	Key			=	0;
	while( Key != ESC ) {
	
		Key	=	Crawcin();
		Key	=	( Key & 0x00FF0000L ) >> 16;

		Display( (int)Key );
	}
	return	0;
}